/*
 * tsi.h
 *
 *  Created on: Apr 4, 2011
 *      Author: B23243
 */

#ifndef TSI_H_
#define TSI_H_

#include <LEDs.h>


#define ELECTRODE0  0
#define ELECTRODE1  1
#define ELECTRODE2  2
#define ELECTRODE3  3
#define ELECTRODE9  9
#define ELECTRODE10  10


#define ELECTRODE9_TOUCH   0x700
#define ELECTRODE10_TOUCH  0x700

#define ELECTRODE9_OVRRUN  0xf000
#define ELECTRODE10_OVRRUN  0xf000

/* Number of scans needed for a touch to remain high to be considered valid */
#define DBOUNCE_COUNTS  0x00000010

#define ELECTRODE_ENABLE_REG    TSI0_PEN

#define ELECTRODE9_COUNT  (uint16)((TSI0_CNTR9)&0x0000FFFF)
#define ELECTRODE10_COUNT  (uint16)((TSI0_CNTR11>>16)&0x0000FFFF)


#define ELECTRODE9_OUTRG  TSI0_THRESHLD9
#define ELECTRODE10_OUTRG  TSI0_THRESHLD10

#define ELECTRODE9_EN_MASK  TSI_PEN_PEN9_MASK
#define ELECTRODE10_EN_MASK  TSI_PEN_PEN10_MASK

#define START_SCANNING  TSI0_GENCS |= TSI_GENCS_STM_MASK
#define ENABLE_EOS_INT  TSI0_GENCS |= (TSI_GENCS_TSIIE_MASK|TSI_GENCS_ESOR_MASK)
#define ENABLE_TSI_ISR  TSI0_GENCS |= TSI_GENCS_TSIIE_MASK
#define ENABLE_TSI      TSI0_GENCS |= TSI_GENCS_TSIEN_MASK
#define DISABLE_TSI     TSI0_GENCS &= ~TSI_GENCS_TSIEN_MASK


//Function Prototype
void tsi_Init(void);
void TSI_GoToLP(void);
void TSI_GoToActive(void);

interrupt void TSI_ISR(void);
void clear_flags(void);
void tsi_calibration(void);
void delay(unsigned long int i);

#endif /* TSI_H_ */
