#ifndef _DEBUG_C_
#define _DEBUG_C_

#include "common.h" /* include peripheral declarations */

/**********STARTFUNC**************************************************
* Name:  sim_clkout_config
* Purpose: Bringing a particular clock on CLKOUT for observability
* Algorithm:
* Inputs:	clk : Clock which has to be observed
* 		div : divider for the clkout pin
* 		pad : selects the pad on which the CLKOUT will come
* Outputs: NONE
* Return value: NONE
* Assumptions : NONE
* Child Functions : NONE
*
***********ENDFUNC***************************************************/
void sim_clkout_config(SIM_CLKOUT_CS_T clk, SIM_CLKOUT_DIV_T div, SIM_CLKOUT_PAD_T pad){
	// configure CLKOUT to come on Chip PAD
	if(pad ==CLKOUT_PTA5){ // PTD5 will be used
		MXC_PTAPF2 = (MXC_PTAPF2 & (~MXC_PTAPF2_A5_MASK)) | MXC_PTAPF2_A5(6);
	}else{ // PTC2 will be used
		MXC_PTCPF3 = (MXC_PTCPF3 & (~MXC_PTCPF3_C3_MASK)) | MXC_PTCPF3_C3(5);
	}
	// configure CLKOUT selection mux and divider
	SIM_CLKOUT = SIM_CLKOUT_CS(clk) | SIM_CLKOUT_CLKOUTDIV(div);
}


#endif //_DEBUG_C_
