/*
 * lpt.c
 *
 *  Created on: Apr 13, 2011
 *      Author: RXAA60
 */
#include "common.h"
#include "lpt.h"

interrupt void lpt0_isr(void){
	print_str("\n [lpt0 ISR]   *****\r\n"); 
	LPTMR0_CSR |=  LPTMR_CSR_TCF_MASK;   // write 1 to TCF to clear the LPT timer compare flag
	LPTMR0_CSR = ( LPTMR_CSR_TEN_MASK | LPTMR_CSR_TIE_MASK | LPTMR_CSR_TCF_MASK  );
}
interrupt void lpt1_isr(void){
    print_str("\n [lpt1 ISR]   *****\r\n"); 
	LPTMR1_CSR |=  LPTMR_CSR_TCF_MASK;   // write 1 to TCF to clear the LPT timer compare flag
	LPTMR1_CSR = ( LPTMR_CSR_TEN_MASK | LPTMR_CSR_TIE_MASK | LPTMR_CSR_TCF_MASK  );
}

void LPT0_Init(int count){
  /* Configure LPT */
  LPTMR0_CMR = LPTMR_CMR_COMPARE(count);  //Set compare value
  LPTMR0_PSR = LPTMR_PSR_PCS(0x1)|LPTMR_PSR_PBYP_MASK;  //Use internal 1khz clock
  LPTMR0_CSR = LPTMR_CSR_TIE_MASK;  //Enable LPT interrupt
  LPTMR0_CSR = LPTMR_CSR_TEN_MASK;  //Enable LPT0 module

}
void LPT1_Init(int count){
  /* Configure LPT */
  LPTMR1_CMR = LPTMR_CMR_COMPARE(count);  //Set compare value
  LPTMR1_PSR = LPTMR_PSR_PCS(0x1)|LPTMR_PSR_PBYP_MASK;  //Use internal 1khz clock
  LPTMR1_CSR = LPTMR_CSR_TIE_MASK;  //Enable LPT interrupt
  LPTMR1_CSR = LPTMR_CSR_TEN_MASK;  //Enable LPT1 module

}
