#include "common.h" /* include peripheral declarations */
#include "user_configure.h"

#include <tsi.h>
/* function prototypes */
void disable_watchdog(void);
void configure_clock_gating(void);
void configure_max_clock_gating(void);
void LED_Port_Init(void);
extern void toggle_led(void);
extern void tsi_demo(void);
extern void pmc_lp_mode();
extern void LEDs_Init(void);


/* variables*/
unsigned char state;

const uint32 NVFOPT@0x0000040C = 0xFFFFFDFE;   //DISABLE EZPORT MODE IN FLASH
// you can also enable low power boot if bit 0 is cleared



void main(void) {
	int i;
	outSRS();
 
#define APP_RAM_START	0x00800000	
  uint32 *pdst;
  uint32 *psrc;
  pdst = (uint32*)APP_RAM_START;
  psrc = (uint32*)APPLICATION_START_ADDRESS;
  for (i=0; i<111;i++){
		  *pdst++=*psrc++;
  }
  
  asm (move.l #APP_RAM_START,d0);
  asm (movec d0,vbr);
  
  EnableInterrupts;
  /* include your code here */
  LEDs_Init(); 
  disable_watchdog();
  configure_clock_gating();
  configure_irq_for_rising_edge();
  print_str("*----------------------------------------*\n");
  print_str("*          TWR-MCF51JF_Quick_Start_Demo    *\n");
  print_str("*----------------------------------------*\n\n");
  LED1_ON;
  state = 1;
  for(;;) {
//	    toggle_led();
//        tsi_demo();
//        DISABLE_TSI;
  } /* loop forever */
  /* please make sure that you never leave main */
}


void LED_Port_Init(void)
{
   // Port Data Direction Register (PTA_DD)
   PTA_DD = 0x01;   //A5 Output
   //Port Data Direction Register (PTC_DD)
   PTC_DD = 0x20;   //C5 Output
   PTA_D = 0x01;    // LED_OR off TWR card on - D9
   PTC_D = 0x20;    // LED_GRM off TWR card on - D14
   MXC_PTAPF4 = MXC_PTAPF4_A0(1); // use PTA0 GPIO(1)  or use ftm1_ch0(4) as output
   MXC_PTCPF2 = MXC_PTCPF2_C5(1); // use PTC5 GPIO(1) as output

}
///////////////////////////////////////////////////////////////////////////////
// DISABLE_WATCHDOG
// Disables the watchdog module.
////////////////////////////////////////////////////////////////////////////////
void disable_watchdog(void)
{
	//Diable Watchdog Timer
	SIM_SCGC4 = SIM_SCGC4_WDOG_MASK;
	SIM_COPC = SIM_COPC_COPT(0);
}

////////////////////////////////////////////////////////////////////////////////
// CONFIGURE_CLOCK_GATING
// Turns on clock gating for select modules.
////////////////////////////////////////////////////////////////////////////////
void configure_clock_gating(void)
{
  /*  Leave I2C3 I2C2 I2C1 I2C0 SPI1 SPI0 UART1 clocks off UART0 Clocks on */
  SIM_SCGC1 |= SIM_SCGC1_UART0_MASK;
  /*  Leave I2S ANL TSI  ADC DAC12B clocks off VREF Clocks on*/
  SIM_SCGC2 |= SIM_SCGC2_VREF_MASK;
  /*  Leave CRC PDB CMT MTIM FTM1 FTM0 clocks off */
  SIM_SCGC3 |= 0x00;
  /*  Turn on IRQ clocks, leave FTFL DMA WDOG clocks off */
  SIM_SCGC4 |= SIM_SCGC4_IRQ_MASK;
  /*   RNGB MFBUS OSC2 OSC1 MCG clocks off */  
  SIM_SCGC5 |= 0x00;  
  /*  Leave PORTF PORTE PORTD PORTC PORTB PORTA on and USBOTG USBDCD  clocks off */  
  SIM_SCGC6 |= SIM_SCGC6_PORTA_MASK |SIM_SCGC6_PORTB_MASK | SIM_SCGC6_PORTC_MASK| SIM_SCGC6_PORTD_MASK |SIM_SCGC6_PORTE_MASK | SIM_SCGC6_PORTF_MASK;
}

////////////////////////////////////////////////////////////////////////////////
// configure_max_clock_gating
// Turns clocks for all modules on
////////////////////////////////////////////////////////////////////////////////
void configure_max_clock_gating(void)
{
	// Enable Clocks of all the modules
	SIM_SCGC1 = 0xFF;
	SIM_SCGC2 = 0xFF;
	SIM_SCGC3 = 0xFF;
	SIM_SCGC4 = 0xFF;
	SIM_SCGC5 = 0xFF;
	SIM_SCGC6 = 0xFF; 
}

