

#include "derivative.h"
#include "psptypes.h"


#define Flash_OK          	0x00
#define Flash_ERROR     	0xFF


uint_8 Flash_LongVerify(uint_32 dst_addr, uint_32 data_addr, uint_32 NumberOfLong);
uint_8 Flash_ByteVerify(uint_32 FlashStartAdd,uint_8 *DataSrcPtr,uint_32 NumberOfBytes);


/*********************************************************
* Name: Flash_verify
*
* Desc: Flash verification
*             
**********************************************************/
uint_8 Flash_LongVerify(uint_32 dst_addr, uint_32 data_addr, uint_32 NumberOfLong) 
{
  do
	 {
		  if(*(uint_32 *)dst_addr != *(uint_32 *)data_addr) // compare two values
		{
		   return Flash_ERROR;
		}	
		
		dst_addr +=4;
		data_addr +=4; 
	}	 
	while(--NumberOfLong);		
    
  return Flash_OK;
}

/*********************************************************
* Name: Flash_verify
*
* Desc: Flash verification
*             
**********************************************************/
extern uint_8 Flash_ByteVerify(uint_32 FlashStartAdd,uint_8 *DataSrcPtr,uint_32 NumberOfBytes)
{
  do
	 {
		if(*(uint_8 *)FlashStartAdd != *(uint_8 *)DataSrcPtr) // compare two values
		{
		   return Flash_ERROR;
		}	
		
		  FlashStartAdd++;
		  DataSrcPtr+=1; 
	}	 
	while(--NumberOfBytes);		
    
  return Flash_OK;
}


