#define __ONLY_INIT_SP
#pragma options align=packed
#include <hidef.h>
#include "psptypes.h"
#include "derivative.h" /* include peripheral declarations */
#include "Bootloader_Drv.h" 
#include "Bootloader_Config.h"
#include "Bootloader_hid.h"
#include "Bootloader_Bdt.h"
#include "flash_FTFL.h"

//static const uint_32 BACKDOOR_03 	@0x00000400  = 0xFFFFFFFF;   
//static const uint_32 BACKDOOR_47 	@0x00000404  = 0xFFFFFFFF;   
static const uint_32 FLASH_PROT_03 @0x00000408  = 0xFFFFFFFE;   			// protect bootloader
//static const uint_32 FLASH_OPTION 	@0x0000040C  = 0xFFFFFFFF;   



//	const byte NVPROT_INIT @0x0000040D  = 0xBB;    // 0x00000000-0x00001FFF are protected 
//	const byte NVOPT_INIT  @0x0000040F  = 0x00;    // flash unsecure    


//extern void _Startup(void);


void FLASHPGM_Copy(void)  ;
static void MCG_Init();

/*Local function definition*/ 

void Watchdog_Reset(void);
extern void USB_Bootloader(void);

static uint_32                      New_sp,New_pc; /* stack pointer and program counter */

#define XTAL8					(3)
#define IMAGE_ADDR    ((uint_32_ptr)APPLICATION_START_ADDRESS)

static void Switch_mode(void);

/*
void Watchdog_Reset(void)
{
	SIM_SRVCOP = 0x55;
	SIM_SRVCOP = 0xAA;
}
*/

void main(void)
{
  Switch_mode();                /* check for bootloader mode */ 

	/* Enable clock source for MTIM, FTM0 FTM1 modules */
	DisableInterrupts;
	MCG_Init();

 	MXC_PTAPF4 = MXC_PTAPF4_A1(1); // use PTA1
    PCTLA_PUE = (1<<1);  //1 Pulling resistor is enabled.
	
  Initialize_USBModule();
//  Flash_Init();
   for(;;) 
   {
	Check_USBBus_Status();             /* use polling method*/
    USB_Bootloader();
	SIM_SRVCOP = 0x55;
	SIM_SRVCOP = 0xAA;

   } 
}

/*****************************************************************************
 * @name     MCG_Init
 *
 * @brief:   Initialization of the Multiple Clock Generator.
 *
 * @param  : None
 *
 * @return : None
 *****************************************************************************
 * Provides clocking options for the device, including a phase-locked
 * loop(PLL) and frequency-locked loop (FLL) for multiplying slower reference
 * clock sources
 ****************************************************************************/
static void MCG_Init()
{
	/* Select MCGOUT */
    SIM_CLKOUT = SIM_CLKOUT_CLKOUTDIV(0)|SIM_CLKOUT_CS(3);
    
    /* First move to FBE mode */
    /* Enable external oscillator, RANGE=1, HGO=1, EREFS=1, LP=0, IRCS=0 */
    MCG_C2 = MCG_C2_RANGE(1) | MCG_C2_HGO_MASK | MCG_C2_EREFS_MASK;
        
    /* Select external oscillator and Reference Divider and clear IREFS to start ext. osc. */
    // CLKS=2, FRDIV=3, IREFS=0, IRCLKEN=0, IREFSTEN=0
    MCG_C1 = MCG_C1_CLKS(2) | MCG_C1_FRDIV(3); 
    /* Wait for oscillator to initialize */
    while (!(MCG_S & MCG_S_OSCINIT_MASK)){};
    /* Wait for Reference clock Status bit to clear */
    while (MCG_S & MCG_S_IREFST_MASK){}; 
    /* Wait for clock status bits to show clock source is ext. ref. clk. */
    while (((MCG_S & MCG_S_CLKST_MASK) >> MCG_S_CLKST_SHIFT) != 0x2){};    
 
    /* Now in FBE
    /* Configure PLL Ref Divider, PLLCLKEN=0, PLLSTEN=0, PRDIV=5
       The crystal frequency is used to select the PRDIV value. Only even frequency crystals are supported
       that will produce a 2MHz reference clock to the PLL. */
    MCG_C5 = MCG_C5_PRDIV(XTAL8); // Set PLL ref. divider to match the crystal used

    /* Ensure MCG_C6 is at the reset default of 0. LOLIE disabled, PLL disabled, clk. monitor disabled, PLL VCO divider is clear */
    MCG_C6 = 0x0;   
 
    /* Set system options dividers
       MCG=PLL, core = MCG  */ 
	SIM_CLKDIV0 =  SIM_CLKDIV0_OUTDIV(0);
    /* Set the VCO divider and enable the PLL for 48MHz, LOLIE=0, PLLS=1, CME=0, VDIV=0 */
    MCG_C6 = MCG_C6_PLLS_MASK; //VDIV = 0 (x24)    
    
    /* Wait for PLL status bit to set */
//    while (!(MCG_S & MCG_S_PLLST_MASK)){}; 
    /* Wait for LOCK bit to set */
//    while (!(MCG_S & MCG_S_LOCK_MASK)){}; 

    
    while (!(MCG_S & (MCG_S_PLLST_MASK+MCG_S_LOCK_MASK))){}; 
    
    
    
    /* Now running PBE Mode */
    
    /* Transition into PEE by setting CLKS to 0 */
    /* CLKS=0, FRDIV=3, IREFS=0, IRCLKEN=0, IREFSTEN=0 */
    MCG_C1 &= ~MCG_C1_CLKS_MASK;

    /* Wait for clock status bits to update */
    while (((MCG_S & MCG_S_CLKST_MASK) >> MCG_S_CLKST_SHIFT) != 0x3){};
            
//    SIM_OSC1 = ((SIM_OSC1 & ~SIM_OSC1_OSC1RANGE_MASK) | SIM_OSC1_OSC1RANGE(0));
    /* Clear HGO for low power operation */
//    SIM_OSC1 &= ~SIM_OSC1_OSC1HGO_MASK;

    /* Select oscillator for external reference */
//    SIM_OSC1 |= SIM_OSC1_OSC1EREFS_MASK;
    /* Enable oscillator */
//    SIM_OSC1 |= SIM_OSC1_OSC1EN_MASK;

    SIM_OSC1 = SIM_OSC1_OSC1EREFS_MASK | SIM_OSC1_OSC1EN_MASK ;
    
    /* Enable the ER clock of oscillators */
    SIM_SCGC5 |=SIM_SCGC5_OSC1_MASK | SIM_SCGC5_OSC2_MASK;
    OSC1_CR = OSC_CR_ERCLKEN_MASK | OSC_CR_EREFSTEN_MASK;
    OSC2_CR = OSC_CR_ERCLKEN_MASK | OSC_CR_EREFSTEN_MASK;    
      
    /* Now running PEE Mode */
    SIM_SOPT3 |= SIM_SOPT3_RWE_MASK; 
    SIM_SOPT1 |= SIM_SOPT1_REGE_MASK;
    SIM_SOPT7 |= 0x80;
    /* Ensure PLL is selected as USB CLK source */
    SIM_CLKDIV1 = 0x00;                 
} 


/*FUNCTION*----------------------------------------------------------------
*
* Function Name  : Switch_mode
* Returned Value : none
* Comments       : Jump between application and bootloader
*     
*
*END*--------------------------------------------------------------------*/


static void Switch_mode(void)
{
    /* Body */
    volatile uint_32  temp;   /* default the button is not pressed */
	  uint_32 i;
	  
    /* Get PC and SP of application region */
    New_sp  = IMAGE_ADDR[0];
    New_pc  = IMAGE_ADDR[1];

    /* Check switch is pressed*/

    SIM_SCGC6 |= SIM_SCGC6_PORTA_MASK;
 	MXC_PTAPF2 = MXC_PTAPF2_A4(1); // use PTA0 GPIO(1)  or use ftm1_ch0(4) as output
    PCTLA_PUE = (1<<4);  //1 Pulling resistor is enabled.
    PCTLA_PUS =(1<<4);  //1 Pullup resistor is selected.


    for(i=0;i<=500;i++){
		if (PTA_D & 0x10){
			if((New_sp != 0xffffffff)&&(New_pc != 0xffffffff))
		    {
		    	MXC_PTBPF4 = MXC_PTBPF4_B0(5);
		       	asm
		        {
		    		move.w   #0x2700,sr
		            move.l   New_sp,a0
		            move.l   New_pc,a1
		            move.l   a0,a7
		            jmp     (a1)
		        }
		     } // EndIf New sp
		} // endIf PTA_D
		SIM_SRVCOP = 0x55;	// feeds the dog 
		SIM_SRVCOP = 0xAA;

    }


  
} /* EndBody */

 

 












