#include "common.h"
#include "SSD_Types.h"
#include "SSD_FTFx.h"
#include "SSD_FTFx_Internal.h"
//#include "Lite_Bootloader.h"

#define USER_MARGIN     0x1
#define FACTORY_MARGIN  0x2
#define FLASH_CMD_SIZE            0x200

// Location in RAM for Flash Command routine
UINT8 flashCmd[FLASH_CMD_SIZE];
pFLASHCOMMANDSEQUENCE pFlashCommandSequence;



// Setup the flash driver
void Init_Flash_Driver(void)
{
    UINT32 flashCmdFr;
    UINT32 flashCmdTo;
    UINT32 i;
    UINT8 value;
    

    // Copy the FlashCommandSequence to RAM
    flashCmdFr = (UINT32)FlashCommandSequence - 1;
    flashCmdTo = (UINT32)&flashCmd;
    for(i=0;i < FLASH_CMD_SIZE;i++)
    {
       value = READ8(flashCmdFr);
       flashCmdFr++;
       WRITE8(flashCmdTo, value);
       flashCmdTo++;
    }
    
    // Load pointer to command sequence in RAM
    pFlashCommandSequence = (pFLASHCOMMANDSEQUENCE)(((UINT32)&flashCmd) + 1);
    

    
}
