/*
 * File:		USB_device.c
 * Purpose:		Main process
 *
 */
#include "common.h"     /* Common definitions */
#include "USB_Reg.h"    /* USB regulator */
#include "usb.h"
#include "usb_icp.h"
//#include "uif.h"

#include "SSD_Types.h"
#include "SSD_FTFL.h"
#include "SSD_FTFL_Internal.h"
#define USER_MARGIN     0x1
#define FACTORY_MARGIN  0x2
/* USB ICP Variables & Flags */

UINT8 gu8ICPStatus;
UINT8 gu16ICPPointer;
UINT32 gu32ICPAddress;
UINT16 gu16ICPLength;
UINT8 gpu8ICPBuffer[FTFL_SECTOR_SIZE];

/* Extern Variables */
extern UINT8 gu8USB_Flags; 
extern UINT8 gu8EP3_OUT_ODD_Buffer[];
extern tBDT tBDTtable[];


extern FLASH_SSD_CONFIG flashSSDConfig;
extern UINT32 FlashInit (PFLASH_SSD_CONFIG PSSDConfig);
extern INT8 Flash_Program(UINT32 FlashAddress);
extern INT8 Flash_Erase_Sector(UINT32 FlashAddress);
extern void USB_Polling(void);
extern pFLASHCOMMANDSEQUENCE pFlashCommandSequence;
extern FLASH_SSD_CONFIG flashSSDConfig;

/********************************************************************/

void main (void)@".usb_hid_icp"
{
#ifdef DEBUG_PRINT
  printf("\n********** USB Device Module Testing **********\n");
#endif
  
//    USB_REG_SET_ENABLE;
//    USB_REG_CLEAR_STDBY;


//  FlashInit(&flashSSDConfig);  

    USB_Init();    

    while(1)
    {
        
    USB_Polling();
    }
}

void ICP_Handler(BootloaderCommand *BLBuffer)@".usb_hid_icp"
{
  UINT32 i;
  UINT8 ret[2];
  UINT32 flashAddress;
  UINT8 failedData;
  static UINT8  deviceErased =0;
  
  ret[0] = 0x5A;    
  if (BLBuffer->C.Command == BL_COMMAND_FILL_BLOCK){

    for (i=0; i<BLBuffer->FillBlock.Length; i++){
      gpu8ICPBuffer[BLBuffer->FillBlock.BufferPointer++] = BLBuffer->FillBlock.Data[i];
    }
  }

  else if (BLBuffer->C.Command == BL_COMMAND_PROGRAM_BLOCK){
 
      ret[1]=0;

      if (deviceErased==0)
      {
        ret[i]=0;
        for (i= USER_ADDR; i<PBLOCK_SIZE; i+=FTFL_SECTOR_SIZE)
        {
          if (ret[1]==0)
          {
            ret[1] = Flash_Erase_Sector(i);
          }
        }
          if (ret[1]==0)
       {
          deviceErased = 1;
       }
      }

      if (ret[1]==0){
        ret[1] = FlashProgramLongword(&flashSSDConfig, BLBuffer->ProgramBlock.FlashAddress, BLBuffer->ProgramBlock.Length, \
                                (UINT32) gpu8ICPBuffer, FlashCommandSequence);
      }
    
      if (ret[1]==0)
      {
       ret[1] = FlashProgramCheck(&flashSSDConfig, BLBuffer->ProgramBlock.FlashAddress, BLBuffer->ProgramBlock.Length, \
                                (UINT8*)gpu8ICPBuffer,     \
                                  (UINT32*) &flashAddress,     \
                                       (UINT8*) &failedData,
                                USER_MARGIN, FlashCommandSequence);
        
      }
      
      EP_IN_Transfer(EP1,(UINT8*)ret,EP1_SIZE);
  }
  
  else if (BLBuffer->C.Command == BL_COMMAND_ERASE)
  {
//      gu8ICPStatus = ICP_STATUS_IDLE;
      ret[1] = Flash_Erase_Sector(BLBuffer->Erase.FlashAddress);

      EP_IN_Transfer(EP1,(UINT8*)ret,EP1_SIZE);

  }
       EP_IN_Transfer(EP0,0,0);
}

