/*
 * File:		USB_device.c
 * Purpose:		Main process
 *
 */
#include "common.h"     /* Common definitions */
#include "USB_Reg.h"    /* USB regulator */
#include "usb.h"
#include "flash.h"
#include "common.h"
#include "SSD_Types.h"
#include "SSD_FTFx.h"
#include "SSD_FTFx_Internal.h"
#include "Lite_Bootloader.h"
#include "kl25z_bootloader.h"

#define USER_MARGIN     0x1
#define FACTORY_MARGIN  0x2
/*
// Flash Driver configuration structure
FLASH_SSD_CONFIG flashSSDConfig =
{
    (uint32)FTFA_BASE_PTR,  // FTFx control register base 
    PFLASH_BLOCK_BASE,      // base address of PFlash block 
    PBLOCK_SIZE,            // size of PFlash block 
    DEFLASH_BLOCK_BASE,     // base address of DFlash block 
    DEBLOCK_SIZE,           // size of DFlash block 
    EERAM_BLOCK_BASE,       // base address of EERAM block 
    EERAM_BLOCK_SIZE,       // size of EERAM block 
    0,                      // size of EEE block 
    DEBUGENABLE,            // background debug mode enable bit 
    NULL_CALLBACK           // pointer to callback function 
};

// Location in RAM for Flash Command routine
UINT8 flashCmd[FLASH_CMD_SIZE];
pFLASHCOMMANDSEQUENCE pFlashCommandSequence;

*/

//#include "uif.h"


/* USB ICP Variables & Flags */
UINT8 gu8ICPStatus;
UINT8 gu16ICPPointer;
UINT32 gu32ICPAddress;
UINT16 gu16ICPLength;
UINT8 gpu8ICPBuffer[FTFL_SECTOR_SIZE];

/* Extern Variables */
extern UINT32 gu8USB_Flags; 
extern UINT8 gu8EP3_OUT_ODD_Buffer[];
extern tBDT tBDTtable[];


extern pFLASHCOMMANDSEQUENCE pFlashCommandSequence;
extern FLASH_SSD_CONFIG flashSSDConfig;

void ICP_Handler(BootloaderCommand *BLBuffer)
{
  UINT32 i;
  UINT8 ret[2];
  UINT32 flashAddress;
  UINT8 failedData;
  static UINT8  deviceErased =0;
    
  ret[0] = 0x5A;    
  if (BLBuffer->C.Command == BL_COMMAND_FILL_BLOCK)
  {

    for (i=0; i<BLBuffer->FillBlock.Length; i++)
    {
      gpu8ICPBuffer[BLBuffer->FillBlock.BufferPointer++] = BLBuffer->FillBlock.Data[i];
    }
  }

  else if (BLBuffer->C.Command == BL_COMMAND_PROGRAM_BLOCK)
  {
        ret[1]=0;
 
     if (deviceErased==0)
      {
        for (i= USER_ADDR; i<PBLOCK_SIZE; i+=FTFx_PSECTOR_SIZE)
        {
          if (ret[1]==0)
          {
            ret[1] = Flash_Erase_Sector(i);
          }
        }
       if (ret[1]==0)
       {
          deviceErased = 1;
       }
      }

  
    if (ret[1]==0)
    {
      ret[1] = FlashProgramLongword(&flashSSDConfig, BLBuffer->ProgramBlock.FlashAddress, BLBuffer->ProgramBlock.Length, \
                                (UINT32) gpu8ICPBuffer, FlashCommandSequence);
    
    }
      if (ret[1]==0)
      {
       ret[1] = FlashProgramCheck(&flashSSDConfig, BLBuffer->ProgramBlock.FlashAddress, BLBuffer->ProgramBlock.Length, \
                                (UINT8*)gpu8ICPBuffer,     \
                                  (UINT32*) &flashAddress,     \
                                       (UINT8*) &failedData,
                                USER_MARGIN, FlashCommandSequence);
        
      }
      EP_IN_Transfer(EP1,(UINT8*)ret,EP1_SIZE);
  }
  
  else if (BLBuffer->C.Command == BL_COMMAND_ERASE){
 //     gu8ICPStatus = ICP_STATUS_IDLE;
        ret[1] = Flash_Erase_Sector(BLBuffer->Erase.FlashAddress);
   
        EP_IN_Transfer(EP1,(UINT8*)ret,EP1_SIZE);

  }
       EP_IN_Transfer(EP0,0,0);
}

