#ifndef __USBICP__
#define __USBICP__

/* Includes */
#include  "USB.h"
#include  "FslTypes.h"
#include  "RingBuffer.h"


//#define CUSTOM_BASE_ADDRESS 0xC000  /* Base Address for Customizable settings */

/* USB_ICP Definitions */

#define ICP_PASS                  0x01;
#define ICP_FAIL                  0xFF;
#define ICP_EP0_SIZE              64        // must equal ep0 size
#define ICP_STATUS_IDLE           0x00
#define ICP_STATUS_BEGIN          0x01
#define BL_COMMAND_ERASE          0x01
#define BL_COMMAND_PROGRAM_BYTE   0x11
#define BL_COMMAND_PROGRAM_BLOCK  0x12
#define BL_COMMAND_FILL_BLOCK     0x13
#define BL_COMMAND_GET_STATUS     0x81

/* TypeDefs */


/* Extern variables */



/* Prototypes */
#pragma pack(2)
typedef union _BootloaderCommand
{
    struct
    {
        uint_8 BootloaderID;           //0
        uint_8 Command;          //1
        uint_8 _byte[ICP_EP0_SIZE-2];
    }C;

    struct
    {
         uint_8 *Data;
    }Data;

    
    __packed struct
    {
        uint_8 BootloaderID;       //0
        uint_8 Command;            //1
        uint_32 FlashAddress;      //2-5
        uint_16 Length;            //6-7
        uint_8 Data[ICP_EP0_SIZE-8];
    }ProgramByte;

    __packed struct
    {
        uint_8 BootloaderID;     //0
        uint_8 Command;          //1
        uint_32 FlashAddress;    //2-5
    }Erase;

   __packed struct
    {
        uint_8 BootloaderID;       //0
        uint_8 Command;            //1
        uint_32 FlashAddress;      //2-5
        uint_16 Length;            //6-7
     }ProgramBlock;
    
  __packed struct
    {
        uint_8 BootloaderID;       //0
        uint_8 Command;            //1
        uint_32 BufferPointer;      //2-5
        uint_16 Length;            //6-7
        uint_8 Data[ICP_EP0_SIZE-8];
    }FillBlock;
     
    
} BootloaderCommand;


void ICP_FillBuffer(uint_8 *Data);
void ICP_Handler(BootloaderCommand *BLCommand);

#endif /* __USBICP__*/