/******************************************************************************
 *
 * Freescale Semiconductor Inc.
 * (c) Copyright 2012-2013 Freescale Semiconductor, Inc.
 * ALL RIGHTS RESERVED.
 *
 ******************************************************************************
 *
 * @file Lite_Bootloader.c
 *
 * @author
 *
 * @version
 *
 * @date 2013-06-14
 *
 * @brief  
 *
 *
 *****************************************************************************
 * Includes
 *****************************************************************************/
#include "common.h"
#include "Lite_Bootloader.h"
#include "usb.h"   
#include "sysinit.h"   
#include "flash.h"
#include "SSD_Types.h"
#include "SSD_FTFx.h"
#include "SSD_FTFx_Internal.h"

/*****************************************************************************
* Global Functions Prototypes
*****************************************************************************/
extern void USB_Polling(void);
extern void USB_Init(void);

/********************************************************************/
int main (void)
{
   
   DisableInterrupts
 
   Check_Bootloader_Mode();    // Bootloader or application?
 
   /* Initialize PLL */
   /* PLL will be the source for MCG CLKOUT so the core, system, and flash clocks are derived from it */ 
   /* Disable the watchdog timer */
   SIM_COPC = 0x00;
   sysinit();
   pll_init();
  
   Init_Flash_Driver();
   
   USB_Init();
    
   for(;;)
   {  
      USB_Polling();
   } 
}
/********************************************************************/

