#include "common.h"
#include "SSD_Types.h"
#include "SSD_FTFx.h"
#include "SSD_FTFx_Internal.h"
#include "Lite_Bootloader.h"

#define USER_MARGIN     0x1
#define FACTORY_MARGIN  0x2

// Flash Driver configuration structure
FLASH_SSD_CONFIG flashSSDConfig =
{
    (uint32)FTFA_BASE_PTR,  /* FTFx control register base */
    PFLASH_BLOCK_BASE,      /* base address of PFlash block */
    PBLOCK_SIZE,            /* size of PFlash block */
    DEFLASH_BLOCK_BASE,     /* base address of DFlash block */
    DEBLOCK_SIZE,           /* size of DFlash block */
    EERAM_BLOCK_BASE,       /* base address of EERAM block */
    EERAM_BLOCK_SIZE,       /* size of EERAM block */
    0,                      /* size of EEE block */
    DEBUGENABLE,            /* background debug mode enable bit */
    NULL_CALLBACK           /* pointer to callback function */
};

UINT8 Flash_Erase_Sector(UINT32 addr)
{
    UINT32 returnCode;
    
    returnCode = FlashEraseSector(&flashSSDConfig, addr, \
                                FTFx_PSECTOR_SIZE, FlashCommandSequence);

      if (returnCode==0)
      {
        returnCode = FlashVerifySection(&flashSSDConfig, addr, FTFx_PSECTOR_SIZE/FTFx_PHRASE_SIZE, 0, FlashCommandSequence);
      }
    
    return returnCode;
}



// Setup the flash driver
void Init_Flash_Driver(void)
{
     // Initialize the Flash Driver
    if(FlashInit(&flashSSDConfig))
        for(;;);        // Error in FlashInit
    
    
}
