
#include "startup.h"
#include "SSD_Types.h"
#include "common.h"
#include "intrinsics.h"
#include "kl25z_bootloader.h"
#include "SSD_FTFx_Internal.h"
#include "Lite_Bootloader.h"

static UINT32 New_sp,New_pc; // stack pointer and program counter 

/***************************************************************************
*
* Checks if bootloader should jump to application, or run the bootloader
* Modified FVH to remove checksum & erased checks - now it simply runs
* application if PE31 high, otherwise returns to run bootloader.
*
***************************************************************************/
void Check_Bootloader_Mode(void) {
  
    void (*app_fn)(void);
    volatile UINT32 i;
    
    New_sp  = ((UINT32*)IMAGE_ADDR)[0];
    New_pc  = ((UINT32*)IMAGE_ADDR)[1];
 
      SIM_SCGC5 |= SIM_SCGC5_PORTE_MASK;  // enable clock to PORTE
      
      // Setup PTE31 as input with pull-up
      PORTE_PCR31 = PORT_PCR_PS_MASK |
                    PORT_PCR_PE_MASK | 
                    PORT_PCR_PFE_MASK |
                    PORT_PCR_MUX(1);      // mux selects GPIO
      
      for(i=0; i<4000; i++);       // delay for pin to stabilize
      
      // Read if pin is pulled low to enter bootloader mode
      // if pin high then run application
        if(GPIOE_PDIR & (UINT32)(1<<31))
        { 
          PORTE_PCR31=0;
          SIM_SCGC5=0;
          
          SIM_SRVCOP = SIM_SRVCOP_SRVCOP(0x55);
          SIM_SRVCOP = SIM_SRVCOP_SRVCOP(0xAA);         // refresh watchdog
          
          /* Run the application */
            app_fn = (void (*)(void)) New_pc;
            __set_MSP(New_sp);
            app_fn();
        }
}


